<?

include('include/basesql.php');
include('include/common-functions.php');

session_start();
//session_register('alx_sort_krit'); session_register('alx_sort_onfirst'); session_register('alx_sort_loc');
$_SESSION['alx_sort_krit'] = $alx_sort_krit;
$_SESSION['alx_sort_onfirst'] = $alx_sort_onfirst;
$_SESSION['alx_sort_loc'] = $alx_sort_loc;

$locations = sqlarr('SELECT location FROM client_locations where enabled="1"', '', 'location');
$locations[] = '';

if($_SESSION['alx_sort_krit']==null)
{
	$_SESSION['alx_sort_krit'] = 'serial';
	$_SESSION['alx_sort_onfirst'] = 1;
	$_SESSION['alx_sort_loc'] = array('DEAD'=>false);
	foreach($locations as $l) $_SESSION['alx_sort_loc'][$l]=true;
}
if(isset($_GET['s_krit']))
{
	$_SESSION['alx_sort_krit']=$_GET['s_krit'];
	$_SESSION['alx_sort_onfirst']=0+$_GET['s_on'];
	$_SESSION['alx_sort_loc']['DEAD']=$_GET['s_dead'];
	foreach($locations as $l) $_SESSION['alx_sort_loc'][$l]=$_GET['s_'.$l];
}

function check_online($dat, $bla)
{
	global $comps;
	global $mcore_port;
	global $ping_timeout;
	if(!isset($comps[$dat['serial']])) return false;

	$retval = ping_host($dat['ip'],$mcore_port,$ping_timeout);
	if($retval==0)
	{
		$comps[$dat['serial']]['online'] = true;
		$comps[$dat['serial']]['ip'] = $dat['ip'];
	}
	else	$comps[$dat['serial']]['ip'] = '<font color=#a00000>'.$dat['ip'].' <small>(no ping)</small></font>';

	$comps[$dat['serial']]['hostname'] = $dat['hostname'];
	$comps[$dat['serial']]['mac'] = $dat['mac'];
}

function sortcomp($a,$b)
{
	if($a['serial']<0 && $b['serial']>0) return -1;
	if($a['serial']>0 && $b['serial']<0) return 1;

	if($_SESSION['alx_sort_onfirst'])
	{
		if($a['online'] && !$b['online']) return -1;
		if($b['online'] && !$a['online']) return 1;
	}
	if($_SESSION['alx_sort_krit']=='hostname')
	{
		if(strtoupper($a['hostname'])<strtoupper($b['hostname'])) return -1;
		else if(strtoupper($a['hostname'])>strtoupper($b['hostname'])) return 1;
	}
	return $a['serial']-$b['serial'];
}

function checkif($b)
{
	if($b) return ' checked';
	else return '';
}

$comps = sqlarr("select client_serials.serial, client_serials.enabled, client_serials.location, client_serials.mac, cfg_network.hostname, state_connected.mtime, state_connected.netboot from client_serials left join cfg_network on client_serials.serial=cfg_network.serial left join state_connected on client_serials.serial=state_connected.serial", "serial");

sqlforeach('SELECT state_connected.serial, state_connected.ip, cfg_network.hostname, state_connected.mac FROM state_connected left join cfg_network on cfg_network.serial=state_connected.serial', 'check_online', null);
usort($comps, 'sortcomp');
echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">';
echo '<head>';
	echo '<title>ALX Config - Index</title>';
	echo '<script language="JavaScript">';
	echo 'function loc(name) { window.open(\'loc.php?location=\'+name, \'\', \'width=350,height=180\'); }';
	echo '</script>';
echo '</head>';
echo '<script type="text/javascript" src="js/jquery-1.2.6.min.js"></script>';
echo '<script type="text/javascript" src="js/jquery.tablesorter.js"></script>';
//echo '<link rel="stylesheet" type="text/css" media="screen" href="js/style.css" />';

if($reload!='off') echo '<body onload="window.setTimeout(\'location.reload()\',60000)">';

echo '<form action="index.php" method="get" style="margin:0px">';
echo '<table width=480><tr>';
// print version info
$version = file_get_contents('.VERSION', FILE_USE_INCLUDE_PATH);
echo '<td><img src="pics/logo.jpg"><font size="1">v'.$version.'</font></td>';
echo '<td align=right valign=top><a href="index.php" style="color:#000000;text-decoration:none; font-weight:bold">[REFRESH]</a></td>';
echo '</tr><tr>';
echo '<td valign=top><b>SORT BY</b> <input onclick="this.form.submit()" type="radio" name="s_krit" value="serial"'.checkif($_SESSION['alx_sort_krit']=='serial').'>serial <input onclick="this.form.submit()" type="radio" name="s_krit" value="hostname"'.checkif($_SESSION['alx_sort_krit']=='hostname').'>hostname<br>';
echo '<input onclick="this.form.submit()" name="s_on" style="margin-left:72px" type="checkbox" value="1"'.checkif($_SESSION['alx_sort_onfirst']).'>online clients on top</td>';
echo '<td align=right valign=top>';

foreach($locations as $l)
	echo '<input onclick="this.form.submit()" type="checkbox" name="s_'.$l.'" value="1"'.checkif($_SESSION['alx_sort_loc'][$l]).'><a href="JavaScript:loc(\''.$l.'\')" style="color:#000000">'.($l=='' ? '?' : $l).'</a>';

echo '<br/>';
echo '<input onclick="this.form.submit()" type="checkbox" name="s_dead" value="1"'.checkif($_SESSION['alx_sort_loc']['DEAD']).'>DEACTIVATED';
echo '</td>';
echo '</tr></table><br>';
echo '</form>';


echo '<table border="1" id="mytab">';
echo '<thead><tr style="font-weight:bold;background-color:#d5e5ff"><th>edit</th><th colspan=3>serial</th><th width=170>hostname</th><th width=100>ip</th><th width=100>mac</th><th width=100>last connected</th>';
echo '<th colspan=2>version</th>';
echo '<th width=100>boot</th>';
echo '<th width=150>up/down</th></tr></thead><tbody>';

foreach($comps as $c)
{
	if(!$_SESSION['alx_sort_loc'][$c['location']]) Continue;
	if($c['enabled']==0 && !$_SESSION['alx_sort_loc']['DEAD']) Continue;

	if($c['online']) $pic='online';
	else $pic='offline';

	if($c['enabled']==0)
	{
		echo '<tr style="text-decoration:line-through; color:#aaaaaa">';
		$pic = 'deact';
	}
	else echo '<tr>';

	echo '<td><input type=button value="EDIT" onclick="location.href=\'show.php?id='.$c['serial'].'\'"></td>';
	echo '<td>'.substr($c['location'],0,3).'</td>';
	echo '<td><img src="pics/'.$pic.'.gif" alt="'.strtoupper($pic).'"></td>';
	echo '<td width=40><b>#'.$c['serial'].'</b></td>';
	echo '<td><nobr>'.$c['hostname'].'</nobr></td>';

	echo '<td><nobr>'.$c['ip'].'</nobr></td>';
	echo '<td><nobr>'.$c['mac'].'</nobr></td>';
	if($c['mtime']) { echo '<td><nobr>'.date('Y-m-d, H:i:s',$c['mtime']).'</nobr></td>'; }
	else echo '<td></td>';

	// get alx version info for
	$alxinfo = sqlfirst('SELECT * FROM client_version WHERE serial='.$c['serial']);
	$alxver = $alxinfo[os];
	$alxutils = $alxinfo[utils];

	if($alxver == '') $alxver='unknown';
	if($alxutils == '') $alxutils='unknown';

	echo '<td>'.$alxver.'</td>';
	echo '<td>'.$alxutils.'</td>';

	// netboot state
	if($c['netboot'] == 1) echo '<td>Netboot (PXE)</td>';
	else echo '<td>Local Disk</td>';

	echo '<td>';
	if($c['online'])
	{
		echo '<input type=button style="width:24%" value="RB" onclick="if(confirm(\'REBOOT CLIENT #'.$c['serial'].' ?\')) window.open(\'reboot.php?client='.$c['serial'].'&ip='.$c['ip'].'&op=reboot\', \'ShutdownWin\', \'width=200,height=100\')">';
		echo '<input type=button style="width:24%" value="SD" onclick="if(confirm(\'SHUTDOWN CLIENT #'.$c['serial'].' ?\')) window.open(\'reboot.php?client='.$c['serial'].'&ip='.$c['ip'].'&op=halt\', \'ShutdownWin\', \'width=200,height=100\')">';
		echo '<input type=button style="width:24%" value="VNC" onclick="window.open(\'vncviewer.php?ip='.$c['ip'].'\', \'VncViewer\', \'width=200,height=100\')">';
		echo '<input type=button style="width:24%" value="SSH" onclick="window.open(\'mindterm.php?ip='.$c['ip'].'\', \'MindTerm\', \'width=200,height=100\')">';
	}
	else echo '<input type=button style="width:100%" value="WOL" onclick="if(confirm(\'WAKE CLIENT #'.$c['serial'].' ?\')) window.open(\'wake_on_lan.php?mac='.$c['mac'].'\', \'WakeWin\', \'width=200,height=100\')">';
	echo '</td>';

	echo '</tr>';
}
echo '</tbody></table><br>';

echo '';

?>
<script type="text/javascript">
$(document).ready(function(){ $("#mytab").tablesorter({ headers: { 0:{sorter: false}, 1:{sorter: false}, 5:{sorter: false}} } ); });
</script>
